=== debian/changelog ===
ecl (16.1.2-4) unstable; urgency=medium

  * Team upload.
  * Fix watch file.
  * Update Vcs-* fields for move to salsa.
  * Move to section lisp (see also #895122).
  * Set Maintainer to debian-common-lisp@l.d.o.
  * Remove obsolete README.building.
  * Use new common-lisp.net Homepage.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 10 Apr 2018 14:07:35 +0200

ecl (16.1.2-3) unstable; urgency=medium

  * Add dependency on libffi-dev for ecl (Closes: #873091).
  * Use debhelper compat level 8.
  * Update Standards-Version to 4.1.0.

 -- Tobias Hansen <thansen@debian.org>  Sat, 02 Sep 2017 02:19:44 +0100

ecl (16.1.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Hansen <thansen@debian.org>  Sun, 07 May 2017 15:38:58 +0100

ecl (16.1.2-1) experimental; urgency=medium

  * New upstream release.
  * Remove bignums-dont-collect-gmp-internal-memory.patch (applied upstream).

 -- Tobias Hansen <thansen@debian.org>  Wed, 29 Mar 2017 21:23:05 +0100

ecl (15.3.7+dfsg1-2) unstable; urgency=medium

  * Add bignums-dont-collect-gmp-internal-memory.patch. (Closes: #777473)
  * Add myself to Uploaders.
  * Bump Standards-Version to 3.9.8.
  * Update debian/watch.

 -- Tobias Hansen <thansen@debian.org>  Mon, 10 Oct 2016 17:34:53 +0100
