=== debian/watch ===
version=4
opts="filenamemangle=s%ecl@ANY_VERSION@\.tgz%ecl-$1.tar.gz%" \
https://common-lisp.net/project/ecl/static/files/release/ecl@ANY_VERSION@(?:@ARCHIVE_EXT@|\.tgz)
