## ecl 16.1.3+ds

=== msvc/Makefile ===
--- 
+++ 
@@ -10,8 +10,8 @@
 
 SHORT_SITE_NAME   =
 LONG_SITE_NAME    =
-ECL_VERSION       = 16.1.2
-ECL_VERSION_NUMBER= 161002
+ECL_VERSION       = 16.1.3
+ECL_VERSION_NUMBER= 160103
 ARCHITECTURE      = PENTIUM4
 SOFTWARE_TYPE     = NT
 SOFTWARE_VERSION  = 5.0
@@ -53,8 +53,6 @@
 ECL_ASDF    =
 # TCP support
 ECL_SOCKETS =
-# X Windows support
-# ECL_CLX     = 1
 # Regression Tests support
 ECL_RT      =
 # Defsystem support
@@ -180,10 +178,6 @@
 !ifdef ECL_SOCKETS
 ECL_MODULES  = $(ECL_MODULES) sockets
 ECL_FEATURES = (cons :wants-sockets $(ECL_FEATURES))
-!endif
-!ifdef ECL_CLX
-ECL_MODULES  = $(ECL_MODULES) clx
-ECL_FEATURES = (cons :wants-clx $(ECL_FEATURES))
 !endif
 !ifdef ECL_RT
 ECL_MODULES  = $(ECL_MODULES) rt
@@ -297,7 +291,6 @@
 	$(CP) $(srcdir)\cmp\load.lsp.in cmp\load.lsp
 cmp/cmpdefs.lsp: $(srcdir)/cmp/cmpdefs.lsp Makefile
 	c\cut "@ECL_CC@" "$(CC)" \
-	    "@CC_IS_CXX@" "nil" \
 	    "@CFLAGS@" "$(CFLAGS)" \
 	    "@CFLAGS_OPTIMIZE@" "$(CFLAGS_OPTIMIZE)" \
 	    "@ECL_CFLAGS@" "" \
@@ -363,11 +356,9 @@
 	$(CP) gmp.lib ..\eclgmp.lib
 	$(CP) gmp.h ..\ecl\gmp.h
 	cd ..
+
 sysfun.lsp:
 	$(CP) $(srcdir)\cmp\sysfun.lsp .\
-
-rt.lisp:
-	$(CP) $(srcdir)\..\contrib\rt\rt.lisp .\
 
 install:
 	IF NOT EXIST "$(prefix)" $(MKDIR) "$(prefix)"
@@ -393,3 +384,7 @@
 	for %i in ($(LIBRARIES) c\dpp.exe BUILD-STAMP help.doc ecl.lib) do $(CP) %i "$(libdir)"
 	for /f %i in ('type MODULES') do $(CP) %i "$(libdir)"
 	for %i in (ecl-static.lib) do IF EXIST %i $(CP) %i "$(libdir)"
+	IF NOT EXIST "$(docdir)" $(MKDIR) "$(docdir)"
+	for %i in (..\LICENSE ..\LGPL ..\README.md ..\CHANGELOG) do $(CP) %i "$(docdir)"
+!if "$(ECL_UNICODE)" != ""
+	IF NOT EXIST "$(libdir)\encodings" $(MKDIR) "$(libdir)\encodings"
