=== debian/changelog ===
ecl (16.1.3+ds-4) unstable; urgency=medium

  * Team upload
  * parallel-ftbfs.patch: new patch, fixes parallel FTBFS (Closes: #949896)
  * Bump S-V to 4.5.0

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 01 Feb 2020 11:39:27 +0100

ecl (16.1.3+ds-3) unstable; urgency=medium

  * Team upload
  * Depend on libgmp-dev instead of now obsolete libgmp3-dev. Thanks to
    Patrice Duroux. (Closes: #934900)
  * libffi-3.3.patch: new patch, fixes FTBFS against libffi 3.3. Thanks to
    Matthias Klose. (Closes: #949288)
  * Bump to debhelper compat level 12
  * Bump S-V to 4.4.1

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 19 Jan 2020 13:52:34 +0100

ecl (16.1.3+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Hansen <thansen@debian.org>  Wed, 16 Jan 2019 17:50:23 +0100

ecl (16.1.3+ds-1) experimental; urgency=medium

  * Team upload
  * New upstream release.
    Strip off embedded code copies of GMP, libffi and boehm GC, to make sure
    that we use the system versions, and to simplify copyright/license
    tracking.
  * no-embedded-copies.patch: new patch, fixes minor issues related to the
    removal of embedded copies.
  * Rewrite d/copyright using machine-readable format 1.0
  * Tarball is now automatically repackaged by uscan

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 30 Oct 2018 12:05:59 +0100

ecl (16.1.2-5) unstable; urgency=medium

  * Team upload
  * Fix typo in Vcs-Git.
  * Remove various obsolete files under debian/
  * format-security.patch: new patch, fixes FTBFS with -Werror=format-security
    (Closes: #714308)
  * Bump to debhelper compat level 11
  * Make the package build twice in a row
  * Remove obsolete Build-Conflicts against automake1.4
  * Add Rules-Requires-Root: no
  * Bump S-V to 4.2.1

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 28 Oct 2018 14:18:20 +0100
